version: "3.5"
services:
        subtraction:
                image: victorgv/subtraction
                build: # build local Dockerfile
                        context: .
                        dockerfile: Dockerfile
                restart: on-failure # restart if this container fails
                deploy: # on swarm mode...
                        replicas: 3 # starts with 6 replicas of this container
                        restart_policy:
                                condition: on-failure # restart if this container fails
                                delay: 5s # wait 5 seconds until restarting process
                        update_config: # on update...
                                parallelism: 2 # updates two replicas at a time
                                failure_action: rollback # if deploy fails, rollback
                                monitor: 1s # wait 1 second for deploy failures
                                order: start-first # start the new version b4 closing the old one
                networks: # connect to
                        - services_net
networks:
        services_net: # "event service replicas <-> other services" network
                external: true
